/*
 * $Id: gamemanager.h,v 1.3 2001/12/19 18:30:30 kenta Exp $
 *
 * Copyright 2001 Kenta Cho. All rights reserved.
 */

/**
 * Gamemanager header file.
 *
 * @version $Revision: 1.3 $
 */
#include <piece.h>

typedef struct {
  int x, y, mx, my, ax, ay;
  int cnt;
  int sx, sy;
  int locked;
} Re;

typedef struct {
  int x, y, mx, my;
  int sx, sy;
  int locked;
} Bullet;

typedef struct {
  int x, y, hp;
  int cnt;
  int tx, ty;
  int trgIdx;
  int btnPressed;
} Player;

#define LASER_POINT_MAX 16

typedef struct {
  int x[LASER_POINT_MAX], y[LASER_POINT_MAX], d[LASER_POINT_MAX];
  int cnt;
} Laser;

#define TARGET_RE 0
#define TARGET_BULLET 1

typedef struct {
  int spc;
  Re *re;
  Bullet *bullet;
  Laser laser;
  int num;
} Lock;

extern int stage, stageReNum;
extern int score, hiScore;

//void loadHiScore();
//void saveHiScore();
void drawObject(PIECE_BMP *bmp, int dx, int dy, int w, int h);
void gotoNextStage();
void setGroundVertices(int r1, int r2, int pct);
void initGamemanager();
void initGame(int s);
void setViewpoint();
int drawRe();
void drawBullet();
void drawPlayer();
void drawLock();
void drawGround();
